

// 2016 (C) MadOrc 
// Ver 1.2 ~ 06.2017

#include <Wire.h>
#include "DHT.h"
#include <ArduinoJson.h>
#include <TimeLib.h>
#include <ESP8266WiFi.h>
#include <WiFiServer.h>
#include <WiFiClient.h> 
#include <ESP8266HTTPClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <UTFT.h>
#include <SPI.h> // not necessary if Arduino IDE version >=1.6.6
#include <pgmspace.h>
#include <EEPROM.h>


#define MM_RT_ST // Если раскомментировано -давление в мм.рт.ст

#define COUNT_TIME        44 // счётное время датчика
#define PSEUDO_USERNAME   "Overseer"
#define HOME_TITLE        " Vault 101"
#define OUTDOOR_TITLE     "Wastelands"


#define NTP_TIMEOUT 2500 //ms таймаут НТП-запроса
#define NTP_INTERVAL 600 //s как часто делать запрос

#define WEATHER_INTERVAL 380 //s как часто делать запрос

#define DHTPIN 2     // what digital pin we're connected to
#define DHTTYPE DHT22 // DHT 22  (AM2302), AM2321

const char *apssid = "Vault_101";
const char *appass = "45667255";

const char* s_ssid = "Overseer_101";
const char* s_pass = "test";


const String w_server     = "api.openweathermap.org" ;
String wu_key;
String wu_location;

String AP_SSID;
String AP_PASS;
int timeZone = 2;     // Zapor


DHT dht(DHTPIN, DHTTYPE);

ESP8266WebServer server(80);

String st;
String content;
int statusCode;
uint16_t ADCkey = 0;


String httpData;
String tmip;

int num_elements_fr = 16; // number of forecast you are retrieving, count of elements in forecast

char* forecast[]={
  "\"temp_min\":","\"temp_max\":","\"icon\":","\"dt\":",
  "\"temp_min\":","\"temp_max\":","\"icon\":","\"dt\":",
  "\"temp_min\":","\"temp_max\":","\"icon\":","\"dt\":",
  "\"temp_min\":","\"temp_max\":","\"icon\":","\"dt\":"};

char* forecast_rename[]={
  "\"celsius_h_0\":","\"celsius_l_0\":","\"icon_0\":","\"dt_0\":",
  "\"celsius_h_1\":","\"celsius_l_1\":","\"icon_1\":","\"dt_1\":",
  "\"celsius_h_2\":","\"celsius_l_2\":","\"icon_2\":","\"dt_2\":",
  "\"celsius_h_3\":","\"celsius_l_3\":","\"icon_3\":","\"dt_3\":"};


char* weekdayNames[]={"Sunday   ", "Monday   ", "Tuesday  ", "Wednesday", "Thursday ", "Friday   ", "Saturday "};
char close_brace ='}';
char comma = ',';
char* iconArray[]={
  "chanceflurries",
  "chancerain", 
  "chancesleet", 
  "chancesnow",
  "chancestorms",
  "Clear",
  "Clouds",
  "flurries",
  "fog",
  "hazy",
  "mostlycloudy",
  "mostlysunny",
  "nt_chanceflurries",
  "nt_chancerain",
  "nt_chancesleet",
  "nt_chancesnow",
  "nt_chancetstorms",
  "nt_clear",
  "nt_cloudy",
  "nt_flurries",
  "nt_fog",
  "nt_hazy",
  "nt_mostlycloudy",
  "nt_mostlysunny",
  "nt_partlycloudy",
  "nt_partlysunny",
  "nt_rain",
  "nt_sleet",
  "nt_snow",
  "nt_sunny",
  "nt_tstorms",
  "partlycloudy",
  "partlysunny",
  "Rain",
  "sleet",
  "Snow",
  "sunny",
  "tstorms"};



///   Thunderstorm Drizzle  Drizzle  Rain Snow Atmosphere Clear Clouds

/*
Day icon  Description
01d.png clear sky         Clear
02d.png few clouds        Clouds
03d.png scattered clouds  Clouds
04d.png broken clouds     Clouds
09d.png shower rain       Rain
10d.png rain              Rain
11d.png thunderstorm      Thunderstorm
13d.png snow              Snow
50d.png mist              Atmosphere

*/
uint8_t t_Date_displayed = 0, last_clock_update_status = 0;
volatile uint8_t screen = 0;

volatile int clock_update_counter = 0, forecast_reload = 0, sensor_update_counter = 0;
int clock_update_rate = NTP_INTERVAL, clock_update_status = 0;

const int buffer=400;//JSON Buffer size





// NTP Servers:
static const char ntpServerNameS[5][25] = { "0.nettime.pool.ntp.org", "1.nettime.pool.ntp.org", "2.nettime.pool.ntp.org", "3.nettime.pool.ntp.org", "1.ua.pool.ntp.org" };


WiFiUDP Udp;
unsigned int localPort = 8888;  // local port UDP 

time_t getNtpTime();
void sendNTPpacket(IPAddress &address);

WiFiUDP Sensor_Udp;
char Sensor_packetBuffer[255];
unsigned int Sensor_localPort = 9999;



char txt[20];

unsigned int err_count = 0;

uint16_t     my_s = 0;
uint16_t     my_m = 0;
uint16_t     my_h = 0;

//uint8_t     lastMinute = 0;

uint8_t     ntp_rotation = 0;


bool      NtpNoConn   = false;
bool      flag_redraw_time = false;
bool      flag_sync_time = true;
bool      flag_run_time = false;
bool      flag_run_weather_request = true;
bool      flag_got_data_from_sensor = false;
bool      flag_redraw_clock_timeout = true;
bool      flag_redraw_weather_timeout_bar = true;
bool      flag_do_measure_dht22 = true;
bool      flag_rad_counted = false, flag_do_blink_rad = false;
bool      setup_mode = false;

uint16_t sbm[COUNT_TIME+1];
uint16_t seconds_passed = 0;
         

uint32_t local_fon = 0,
         fon_pulses = 0;
int d_local_t = 0, d_local_h = 0;





// Modify the line below to match your display and wiring:
UTFT myGLCD ( ILI9341_S5P, 15, 5, 4 );


//extern uint8_t SmallFont[];
extern uint8_t RusFixedSysFont[];
extern uint8_t BigRusFont[];
//extern uint8_t SevenSegNumFont[];
//extern uint8_t ArialNumFont[];
extern uint8_t SixteenSegment24x36[];
extern uint8_t DotMatrix_Num[];

extern short unsigned int partlycloudy[0x9C4];
extern short unsigned int chanceflurries[0x9C4];
extern short unsigned int chancerain[0x9C4];
extern short unsigned int chancesnow[0x9C4];
extern short unsigned int chancestorms[0x9C4];
extern short unsigned int cler[0x9C4];
extern short unsigned int cloudy[0x9C4];
extern short unsigned int flurries[0x9C4];
extern short unsigned int fog[0x9C4];
extern short unsigned int mostlycloudy[0x9C4];
extern short unsigned int rain[0x9C4];
extern short unsigned int snow[0x9C4];
extern short unsigned int tstorms[0x9C4];
extern short unsigned int nodata[0x9C4];

extern short unsigned int rainchance[0xE1];

extern short unsigned int rad_ok[0x2B2];
extern short unsigned int rad_warn[0x2B2];
extern short unsigned int rad_crit[0x2B2];

extern short unsigned int symb_humidity[0x1B8];
extern short unsigned int symb_temperature[0x1B8];
extern short unsigned int symb_pressure[0x1B8];
extern short unsigned int symb_radiation[0x1B8];

extern short unsigned int symb_wastes[0x1CC];
extern short unsigned int symb_vault[0x1CC];

extern short unsigned int vt[0x41A0];
 
const uint8_t utf8_rus_charmap[] PROGMEM = {'A',128,'B',129,130,'E',131,132,133,134,135,'K',136,'M','H','O',137,'P','C','T',138,139,'X',140,141,
142,143,144,145,146,147,148,149,'a',150,151,152,153,'e',154,155,156,157,158,159,160,161,162,'o',163,'p','c',164,'y',165,'x',166,167,168,169,170,
171,172,173,174,175};

volatile  uint32_t pulsa = 0;

int Sensor_packetSize;

float local_t, local_h;


void Rad_Pulse()
{
  sbm[0]++;
  // нельзя так, глучит delay(1); // noise filter
  flag_do_blink_rad = true;
}



void timer_1Hz_Isr()
{
//if (flag_run_time) ntp_time++;
flag_redraw_time = true;

flag_do_measure_dht22 = true;

if (forecast_reload++ > WEATHER_INTERVAL) {forecast_reload = 0; flag_run_weather_request = true; }

if (clock_update_counter++ > clock_update_rate)  { clock_update_counter = 0; flag_redraw_clock_timeout = true; }

if (sensor_update_counter < 78) sensor_update_counter++;

if (seconds_passed < COUNT_TIME) 
   { 
    seconds_passed++; //для неполного расчёта
    flag_rad_counted = false;
   }
   else
   flag_rad_counted = true;



 for(uint8_t k=COUNT_TIME+1;k>0;k--)
    {
  sbm[k]=sbm[k-1];
  }
    sbm[0]=0;


timer0_write(ESP.getCycleCount() + 80000000L); // 80MHz == 1sec
}

 
  
void setup (  ) {

ESP.eraseConfig();

//wdt_enable(WDTO_8S);
//wdt_disable();  
  
  pinMode(16, OUTPUT); // LED импульсов датчика
  digitalWrite(16, LOW); // на всякий..
screen = 0;
  Serial.begin(115200);
  Serial.println("");
  Serial.println("");


delay(1000);
  //WiFi.printDiag(Serial);
    myGLCD.InitLCD ( PORTRAIT );

  

myGLCD.setFont(RusFixedSysFont);
myGLCD.setColor(102,255,102);
myGLCD.setBackColor(VGA_BLACK);

myGLCD.clrScr (  );

myGLCD.print(String("RobCo (TM) WiFi TERMLINK"), 2, 5 ,0);

char pseudousername[14];
strcpy(pseudousername, PSEUDO_USERNAME);
myGLCD.print(String("Logon: "), 2, 26 ,0);

for(uint8_t dx=0; dx<(strlen(pseudousername)+1); dx++)
  {
  myGLCD.print((String)pseudousername[dx], 2+(8*7)+(dx*8), 26 ,0);
  delay(70);
  }

myGLCD.print(String("Password: "), 2, 40 ,0);

for(uint8_t dx=0; dx<9; dx++)
  {
  myGLCD.print(String("*"), 2+(8*10)+(dx*8), 40 ,0);
  delay(70);
  }


  Serial.print("Free Memory: ");
  Serial.println(ESP.getFreeHeap());

  uint8_t mac[6];
  WiFi.macAddress(mac);
  String macs = "MAC " + macToStr(mac);

  
//  Serial.print("MAC: ");
  Serial.println(macs);

sprintf(txt, "MEM %i", ESP.getFreeHeap());
myGLCD.print(String(txt), 2, 60 ,0);

myGLCD.print(String(macs), 2, 74 ,0);



  // read eeprom for ssid and pass
EEPROM.begin(158);
  Serial.println("Reading EEPROM ssid");
  String esid;
  for (int i = 0; i < 32; ++i)
  {
    if (char(EEPROM.read(i))) esid += char(EEPROM.read(i));
  }
  Serial.print("SSID: ");
  Serial.println(esid);
  AP_SSID = esid;
  Serial.println("Reading EEPROM pass");
  String epass = "";
  for (int i = 32; i < 96; ++i)
  {
    if (char(EEPROM.read(i))) epass += char(EEPROM.read(i));
  }
  Serial.print("PASS: ");
  Serial.println(epass);
  AP_PASS = epass;

  String etimezone = "";
  for (int i = 96; i < 99; ++i)
  {
    etimezone += char(EEPROM.read(i));
  }
  Serial.print("TimeZone: ");
  Serial.println(etimezone);
  timeZone = etimezone.toInt();
  Serial.println(timeZone);


  String e_wu_key = "";
  for (int i = 99; i < 131; ++i)
  {
    if (char(EEPROM.read(i))) e_wu_key += char(EEPROM.read(i));
  }
  Serial.print("WU Key: ");
  Serial.println(e_wu_key);
  wu_key = e_wu_key;
  
  String e_wu_location = "";
  for (int i = 131; i < 157; ++i)
  {
    if (char(EEPROM.read(i))) e_wu_location += char(EEPROM.read(i));
  }
  Serial.print("Location: ");
  Serial.println(e_wu_location);
  wu_location = e_wu_location;

  EEPROM.end();


  ADCkey = analogRead(A0);  //Считываем значение кнопки
  Serial.print("ADC: ");
  Serial.println(ADCkey);
  if (ADCkey > 500)         //Если Нажата - поднимаем точку доступа для настройки
  { //////////////////////////////////////////////////
  setup_mode = true;
  
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(500);
  int n = WiFi.scanNetworks();      //Сканируем видимые точки
  Serial.println("scan done");
  if (n == 0)
    Serial.println("no networks found");
  else
  {
    Serial.print(n);
    Serial.println(" networks found");
    for (int i = 0; i < n; ++i)         //Выводим найденные в терминал
    {
      // Print SSID and RSSI for each network found
      Serial.print(i + 1);
      Serial.print(": ");
      Serial.print(WiFi.SSID(i));
      Serial.print(" (");
      Serial.print(WiFi.RSSI(i));
      Serial.print(")");
      Serial.println((WiFi.encryptionType(i) == ENC_TYPE_NONE) ? " " : "*");
      delay(10);
    }
  }
  Serial.println("");
  st = "<ol>";
  for (int i = 0; i < n; ++i)           //Выводим найденные в веб
  {
    // Print SSID and RSSI for each network found
    st += "<li>";
    st += WiFi.SSID(i);
    st += " (";
    st += WiFi.RSSI(i);
    st += ")";
    st += (WiFi.encryptionType(i) == ENC_TYPE_NONE) ? " " : "*";
    st += "</li>";
  }
  st += "</ol>";
  
  WiFi.disconnect();
  delay(500);
  WiFi.mode(WIFI_OFF); // найух, иначе глючит
  delay(500);

  IPAddress apIP(192,168,10,1);
  WiFi.mode(WIFI_AP);       // WiFi.mode(WIFI_AP);
  WiFi.softAPConfig(apIP,apIP,IPAddress(255,255,255,0));
  WiFi.softAP(s_ssid);

  //WiFi.mode(WIFI_AP);
  //WiFi.softAP(s_ssid, s_passphrase, 6);   //Поднимаем точку доступа, пароль менее 8 букв = нет пароля
  

  Serial.print("softap ");
  Serial.println(s_ssid);
  launchWeb();                       //Запускаем веб сервер
  Serial.println("web started");


    sprintf(txt, "Started AP %s", s_ssid);
    myGLCD.print(txt, 2, 88 ,0);

    
    myGLCD.print(String("Setup on http://192.168.10.1/"), 2, 102 ,0);



 } //////////////////////////////////////
 else
 { /// normal start
setup_mode = false;

 

// сервер-клиент:
  IPAddress apIP(192,168,10,1);
  WiFi.mode(WIFI_AP_STA);       // WiFi.mode(WIFI_AP);
  WiFi.softAPConfig(apIP,apIP,IPAddress(255,255,255,0));
  WiFi.softAP(apssid, appass);

  




  // Соединение с WiFi
  
  if ( !ConnectWiFi(AP_SSID.c_str(), AP_PASS.c_str()) ) {
    Serial.println("Reset ESP8266 ...");
    delay(1000);
    ESP.reset();
  }
  delay(1000);
  
  Serial.print("Signal: ");
  Serial.println(WiFi.RSSI());

    sprintf(txt, "SIGNAL: %idBm", WiFi.RSSI());
    myGLCD.print(txt, 2, 144 ,0);

  
  // Инициализация UDP соединения с NTP сервером
  Serial.println("Starting UDP");
  Udp.begin(localPort);
  Serial.print("Local port: ");
  Serial.println(Udp.localPort());
  Serial.println("waiting for sync");
  setSyncProvider(getNtpTime);
 
  Sensor_Udp.begin(Sensor_localPort);  
  Serial.println("UDP Sensor server started");
  Serial.println();
  
  

if (screen == 0)
  {
    for (uint8_t v=0; v<8; v++)
    {
    if (v%2) myGLCD.print(String("> \xC5"), 2, 242 ,0); else myGLCD.print(String(">  "), 2, 242 ,0);
    delay(700);    
    }
  }


myGLCD.clrScr (  );

//time
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 3, 4, 136 , 46 );  
myGLCD.setColor(6,230,153);
myGLCD.drawRoundRect ( 3, 4, 136 , 46 );  

//dates
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 140, 13, 237 , 46 );  
myGLCD.setColor(6,230,153);
myGLCD.drawRoundRect ( 140, 13, 237 , 46 );  


// weather frame
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 1, 48, 240 , 146 );  
myGLCD.setColor(6,230,153);
myGLCD.drawRoundRect ( 1, 48, 240 , 146 );  

 myGLCD.drawBitmap (8, 59, 224, 75, vt, 1); // заглушка

//street
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 1, 156, 118 , 320 );  
myGLCD.setColor(6,230,153);
myGLCD.drawRoundRect ( 1, 156, 118 , 320 );  

  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(0,0,0);
  myGLCD.setFont(RusFixedSysFont);


  myGLCD.drawBitmap (91, 159, 23, 20, symb_wastes, 1);
  
  sprintf(txt, OUTDOOR_TITLE);
  printRus(myGLCD, txt, 7, 168 ,0);

  myGLCD.drawLine (7, 162, 86, 162);

  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(0,0,0);
  myGLCD.setFont(DotMatrix_Num);
  myGLCD.drawBitmap (6, 183, 20, 22, symb_temperature, 1);
  printRus(myGLCD, "--", 28, 183 ,0);

  myGLCD.setFont(RusFixedSysFont);
  printRus(myGLCD, "~C", 78, 193 ,0); // \x7e


  myGLCD.setFont(DotMatrix_Num);
  myGLCD.drawBitmap (6, 208, 20, 22, symb_humidity, 1);
  printRus(myGLCD, "--", 28, 208 ,0);
  myGLCD.setFont(RusFixedSysFont);
  printRus(myGLCD, "%RH", 64, 218 ,0);

  myGLCD.setFont(DotMatrix_Num);
  myGLCD.drawBitmap (4, 233, 20, 22, symb_pressure, 1);
  printRus(myGLCD, "----", 25, 233 ,0);
  myGLCD.setFont(RusFixedSysFont);
  #ifdef MM_RT_ST
  printRus(myGLCD, "mm ", 91, 243 ,0);
  #else
  printRus(myGLCD, "hPa", 91, 243 ,0);
  #endif
  myGLCD.setFont(DotMatrix_Num);
  myGLCD.drawBitmap (6, 259, 20, 22, symb_radiation, 1);
  printRus(myGLCD, "---", 30, 259 ,0);
  myGLCD.setFont(RusFixedSysFont);
  printRus(myGLCD, "uR/H", 80, 269 ,0);


  myGLCD.setFont(RusFixedSysFont);
  sprintf(txt, "Рад. фон");
  printRus(myGLCD, txt, 7, 289 ,0);
  sprintf(txt, "  n/a    ");
  printRus(myGLCD, txt, 7, 303 ,0);
  myGLCD.drawBitmap (92, 287, 23, 30, rad_ok, 1);


//Home
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 122, 156, 240 , 320 );  
myGLCD.setColor(6,230,153);
myGLCD.drawRoundRect ( 122, 156, 240 , 320 );  

  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(0,0,0);
  myGLCD.setFont(RusFixedSysFont);


  myGLCD.drawBitmap (213, 159, 23, 20, symb_vault, 1);
  
  sprintf(txt, HOME_TITLE);
  printRus(myGLCD, txt, 130, 168 ,0);

  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(0,0,0);
  myGLCD.setFont(DotMatrix_Num);
  myGLCD.drawBitmap (128, 189, 20, 22, symb_temperature, 1);
  printRus(myGLCD, "--", 150, 189 ,0);

  myGLCD.setFont(RusFixedSysFont);
  printRus(myGLCD, "~C", 200, 199 ,0);


  myGLCD.setFont(DotMatrix_Num);
  myGLCD.drawBitmap (128, 223, 20, 22, symb_humidity, 1);
  printRus(myGLCD, "--", 150, 223 ,0);
  myGLCD.setFont(RusFixedSysFont);
  printRus(myGLCD, "%RH", 186, 233 ,0);


  myGLCD.setFont(DotMatrix_Num);
  myGLCD.drawBitmap (128, 259, 20, 22, symb_radiation, 1);
  printRus(myGLCD, "---", 152, 259 ,0);
  myGLCD.setFont(RusFixedSysFont);
  printRus(myGLCD, "uR/H", 202, 269 ,0);


  myGLCD.setFont(RusFixedSysFont);
  sprintf(txt, "Рад. фон");
  printRus(myGLCD, txt, 129, 289 ,0);
  sprintf(txt, "  n/a    ");
  printRus(myGLCD, txt, 129, 303 ,0);
  myGLCD.drawBitmap (214, 287, 23, 30, rad_ok, 1);

/*
for (uint16_t l=1; l<320;l+=2)
  {
    myGLCD.setColor(11,27,26);
    myGLCD.drawLine ( 1, l, 240 , l );
    myGLCD.setColor(3,144-(l/5),5);
    myGLCD.drawLine ( 1, l+1, 240 , l+1 );
    
  }
*/

noInterrupts();

pinMode(12, INPUT);
attachInterrupt(12, Rad_Pulse, FALLING);

timer0_isr_init();
timer0_attachInterrupt(timer_1Hz_Isr);
timer0_write(ESP.getCycleCount() + 80000000L); // 80MHz == 1sec

interrupts();

delay(1000); //даем стабилизироваться таймерам
screen = 1;
 } // normal start end
}

  
void loop (  ) {
  if (setup_mode)
  { //setup run
      server.handleClient(); // виснем тут
  }
  else
  {//normal run

  if ( flag_redraw_time ) {
    flag_redraw_time = false;
    Draw_Time();
  }
  


if (flag_run_weather_request)
{
  flag_run_weather_request = false;
  Weather_Request();
}

if (flag_do_measure_dht22)
{
      local_t = dht.readTemperature(); 
      local_h = dht.readHumidity();

    fon_pulses =0;
    for (uint8_t idx=1; idx<seconds_passed+1; idx++)
    {
      fon_pulses += sbm[idx];
    }
    
    local_fon = fon_pulses * COUNT_TIME / seconds_passed;
      
flag_do_measure_dht22 = false;
}

if (flag_do_blink_rad)
  {
  flag_do_blink_rad = false;
  digitalWrite(16, HIGH);
  delay(50);
  digitalWrite(16, LOW);
  
  }

  Sensor_packetSize = Sensor_Udp.parsePacket();
  if (Sensor_packetSize) 
  {
    int Sensor_len = Sensor_Udp.read(Sensor_packetBuffer, 255);
    if (Sensor_len > 0) Sensor_packetBuffer[Sensor_len-1] = 0;
  Serial.print("Got from sensor:");
  Serial.println(Sensor_packetBuffer);
    flag_got_data_from_sensor = true;
    Sensor_Parse(Sensor_packetBuffer);
   }

  // Если нет соединения с интернетом, перезагружаемся
  if ( err_count > 10 ) {
    Serial.println("NTP connection lost");
    Serial.println("Reset ...");
    ESP.reset();

  }
  //delay(100);




  } // /normal run

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void Weather_Request() {

/*

HTTPClient http;
  http.begin("https://calm-falls-41696.herokuapp.com/api/v1/cards");
  http.addHeader("Content-Type", "application/json");
  int httpCode = http.GET();
  Serial.println(httpCode);
  if(httpCode == HTTP_CODE_OK) {
  Serial.print("HTTP response code ");
    Serial.println(httpCode);
    String response = http.getString();
    Serial.println(response);
  }
  http.end();


 
  
  */
  unsigned int i = 0; //timeout counter
  char json[buffer]="{"; // array for Json parsing
  int n = 1;          // character counter for json
  unsigned int hstr = 0;        // character counter for http string

if ((!wu_key.length())||(!wu_location.length()))
  {
    Serial.println(" key or location not set!");
    return;
  }

const String w_url = "http://" + w_server + "/data/2.5/forecast?q=" + wu_location + "&appid=" + wu_key + "&units=metric";

// http://api.openweathermap.org/data/2.5/forecast?q=zaporizhzhya&appid=7a115f1c8243ef58a9c0ffb18a765264&units=metric 

 Serial.println(w_url);
  HTTPClient client;
  //client.setTimeout(1000);
  Serial.print("Connecting to openweathermap server ");
  

if (screen == 0) myGLCD.print(String(">Connect to weather forecast"), 2, 200 ,0);

flag_redraw_weather_timeout_bar = true;

  client.begin(w_url);

  int httpCode = client.GET();

  if (httpCode > 0) {
if (screen == 0) myGLCD.print(String("Weather forecast OK!         "), 2, 214 ,0);
    Serial.printf("successfully, code: %d\n", httpCode);
    
    if (httpCode == HTTP_CODE_OK) {
      httpData = client.getString();
    }
   
if (httpData.indexOf("error", 152) > -1) 
// 
{ wdt_reset(); httpData = ""; Serial.println("WU Server answered error."); } // если север дал любую ошибку, не парсим

//if (httpData.length() < 260) { Serial.println("WU Server answered error."); } // если север дал любую ошибку, не парсим
  else
  { // err  
      Serial.println("Parse started.");
    for (int j=0;j<num_elements_fr;j++){
      
      hstr = httpData.indexOf(forecast[j], hstr+1);
      
      String Str1 = forecast_rename[j];
      String StrT = forecast[j];
      
      hstr = hstr + StrT.length();
      
      for (int l=0; l<(Str1.length());l++)
      {json[n] = Str1[l];
      n++;}


      while (i<6000) 
      {
        if(httpData[hstr]) {
          char c = httpData[hstr];
          if (c== ',') {break;}
          if(c== '}') {break;}

          json[n]=c;
          n++;
          i=0;
        }
        hstr++;
        i++;
      }

      if (j==num_elements_fr-1)
      {   
        
        json[n]=close_brace;
        
      
      }
      else
      {json[n]=comma;}
      n++;

    }
      
Serial.println(json);
// wdt_reset();
Serial.println("Parse in progress...");
Weather_parse(json);
  }// err
  }
  else 
  {
  if (screen == 0) myGLCD.print(String("Connect FAIL! Retry in 1 min."), 2, 214 ,0);
  Serial.printf("failed, error: %s\n", client.errorToString(httpCode).c_str());
  }

//  postingInterval = find ? 600L * 1000L : 60L * 1000L;
  client.end();
}


void Sensor_Parse(char json[300])
{
uint16_t scaled_fon = 0;
char rad_units[5];

    StaticJsonBuffer<buffer> jsonBuffer;
    JsonObject& root = jsonBuffer.parseObject(json);
    
    if (!root.success())
    {
      Serial.print("?fparseObject() failed on sensor");
    }

    int s_tem = root["temperature"];
    int s_hum = root["humidity"];
    int s_pres = root["pressure"];
    int s_fon = root["gamma"];

// myGLCD.drawBitmap (8, 242, 224, 75, vt, 1);

  sensor_update_counter = 0;

  
  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(0,0,0);
  myGLCD.setFont(DotMatrix_Num);

  if ((s_tem < 100)&&(s_tem > -100)) 
    {
    sprintf(txt, "%3i", s_tem);
    printRus(myGLCD, txt, 28, 183 ,0);
    }

  sprintf(txt, "%2i", s_hum);
  printRus(myGLCD, txt, 28, 208 ,0);

  sprintf(txt, "%4i", s_pres);
  printRus(myGLCD, txt, 25, 233 ,0);


if (s_fon > 999999) { scaled_fon = s_fon/1000000; strcpy(rad_units, "R/H "); }
else if (s_fon > 999) { scaled_fon = s_fon/1000; strcpy(rad_units, "mR/H"); }
else{ scaled_fon = s_fon; strcpy(rad_units, "uR/H"); }

  sprintf(txt, "%3i", scaled_fon);
  printRus(myGLCD, txt, 30, 259 ,0);
  myGLCD.setFont(RusFixedSysFont);
  printRus(myGLCD, rad_units, 80, 269 ,0);


  myGLCD.setFont(RusFixedSysFont);
      if (s_fon > 120){ sprintf(txt, "   ОПАСНЫЙ"); myGLCD.drawBitmap (92, 287, 23, 30, rad_crit, 1); }
  else if (s_fon > 50) { sprintf(txt, "повышенный"); myGLCD.drawBitmap (92, 287, 23, 30, rad_warn, 1); }
            else  { sprintf(txt, "нормальный"); myGLCD.drawBitmap (92, 287, 23, 30, rad_ok, 1); }
 printRus(myGLCD, txt, 6, 303 ,0);
  
  

  

}

void Weather_parse(char json[400]) {

    StaticJsonBuffer<buffer> jsonBuffer;
    JsonObject& root = jsonBuffer.parseObject(json);
    
    if (!root.success())
    {
      Serial.print("?fparseObject() failed");
    }

    const  char* celsius_h_0 = root["celsius_h_0"];
    const  char* celsius_l_0 = root["celsius_l_0"];
    const char* icon_0 = root["icon_0"];
    unsigned long dt_0 = root["dt_0"];

  sprintf(txt, "%02d.%02d", day(dt_0), month(dt_0));
  Serial.println(txt);

  
  // dtostrf(<переменная с плавающей>, <символов всего>, <символов после запятой>, <переменная char>)
 
/* 
  char msgBuffer[20];           // длина строки должна быть достаточно большой.
  float testFloat = 123.45;
  client.Publish("...topic...", dtostrf(testFloat, 6, 2, msgBuffer));
  */  
  
    const char* celsius_h_1 = root["celsius_h_1"];
    const char* celsius_l_1 = root["celsius_l_1"];
    const char* icon_1 = root["icon_1"];
    unsigned long dt_1 = root["dt_1"];


    const char* celsius_h_2 = root["celsius_h_2"];
    const char* celsius_l_2 = root["celsius_l_2"];
    const char* icon_2 = root["icon_2"];
    unsigned long dt_2 = root["dt_2"];
 

    const char* celsius_h_3 = root["celsius_h_3"];
    const char* celsius_l_3 = root["celsius_l_3"];
    const char* icon_3 = root["icon_3"];
    unsigned long dt_3 = root["dt_3"];

//0
float f_h_0 = atof(celsius_h_0);
float f_l_0 = atof(celsius_l_0);
char str_temp_h_0[6];
char str_temp_l_0[6];
//1
float f_h_1 = atof(celsius_h_1);
float f_l_1 = atof(celsius_l_1);
char str_temp_h_1[6];
char str_temp_l_1[6];
//2
float f_h_2 = atof(celsius_h_2);
float f_l_2 = atof(celsius_l_2);
char str_temp_h_2[6];
char str_temp_l_2[6];
//3
float f_h_3 = atof(celsius_h_3);
float f_l_3 = atof(celsius_l_3);
char str_temp_h_3[6];
char str_temp_l_3[6];

dtostrf(f_h_0,1,0,str_temp_h_0);
dtostrf(f_l_0,1,0,str_temp_l_0);

dtostrf(f_h_1,1,0,str_temp_h_1);
dtostrf(f_l_1,1,0,str_temp_l_1);

dtostrf(f_h_2,1,0,str_temp_h_2);
dtostrf(f_l_2,1,0,str_temp_l_2);

dtostrf(f_h_3,1,0,str_temp_h_3);
dtostrf(f_l_3,1,0,str_temp_l_3);

sprintf(txt,"%s/%s, %s/%s, %s/%s, %s/%s", str_temp_h_0, str_temp_l_0,str_temp_h_1, str_temp_l_1,str_temp_h_2, str_temp_l_2,str_temp_h_3, str_temp_l_3);
Serial.println(txt);

// weather frame
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 1, 48, 240 , 146 );  
myGLCD.setColor(6,230,153);
myGLCD.drawRoundRect ( 1, 48, 240 , 146 );  




  myGLCD.setColor(210,255,210);
  myGLCD.setBackColor(VGA_BLACK);
  myGLCD.setFont(RusFixedSysFont);
sprintf(txt, "%02d.%02d", day(dt_0), month(dt_0));
myGLCD.print(txt, 24, 51 ,0);

sprintf(txt, "%02d.%02d", day(dt_1), month(dt_1));
myGLCD.print(txt, 80, 51 ,0);

sprintf(txt, "%02d.%02d", day(dt_2), month(dt_2));
myGLCD.print(txt, 137, 51 ,0);

sprintf(txt, "%02d.%02d", day(dt_3), month(dt_3));
myGLCD.print(txt, 193, 51 ,0);

/////myGLCD.print(icon_2, 1, 188 ,0);

Draw_Weather_Icon(icon_0, 11, 63);
Draw_Weather_Icon(icon_1, 67, 63);
Draw_Weather_Icon(icon_2, 123, 63);
Draw_Weather_Icon(icon_3, 179, 63);

myGLCD.setColor(102,255,102);

myGLCD.setFont(RusFixedSysFont);
sprintf(txt, "%s/%s", str_temp_h_0, str_temp_l_0);
if (strlen(txt) < 7) strcat(txt, "\xC6");
myGLCD.print(txt, 5, 115 ,0);

sprintf(txt, "%s/%s", str_temp_h_1, str_temp_l_1);
if (strlen(txt) < 7) strcat(txt, "\xC6");
myGLCD.print(txt, 64, 115 ,0);

sprintf(txt, "%s/%s", str_temp_h_2, str_temp_l_2);
if (strlen(txt) < 7) strcat(txt, "\xC6");
myGLCD.print(txt, 123, 115 ,0);

sprintf(txt, "%s/%s", str_temp_h_3, str_temp_l_3);
if (strlen(txt) < 7) strcat(txt, "\xC6");
myGLCD.print(txt, 182, 115 ,0);

  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(VGA_TRANSPARENT);
  
/*
if (pop_0) 
    { 
  myGLCD.drawBitmap (13, 128, 15, 15, rainchance, 1);
  sprintf(txt, "%3u%%", pop_0);
  printRus(myGLCD, txt, 26, 133 ,0);
    }

if (pop_1) 
    { 
  myGLCD.drawBitmap (69, 128, 15, 15, rainchance, 1);
  sprintf(txt, "%3u%%", pop_1);
  printRus(myGLCD, txt, 82, 133 ,0);
    }
    
if (pop_2) 
    { 
  myGLCD.drawBitmap (125, 128, 15, 15, rainchance, 1);
  sprintf(txt, "%3u%%", pop_2);
  printRus(myGLCD, txt, 138, 133 ,0);
    }
    
if (pop_3) 
    { 
  myGLCD.drawBitmap (181, 128, 15, 15, rainchance, 1);
  sprintf(txt, "%3u%%", pop_3);
  printRus(myGLCD, txt, 194, 133 ,0);
    }
*/



/*
Serial.printf("%s/%s ico:%s date:%s", celsius_h_0, celsius_l_0, icon_0, dt_txt_0);
Serial.printf("%s/%s ico:%s date:%s", celsius_h_1, celsius_l_1, icon_1, dt_txt_1);
Serial.printf("%s/%s ico:%s date:%s", celsius_h_2, celsius_l_2, icon_2, dt_txt_2);
Serial.printf("%s/%s ico:%s date:%s", celsius_h_3, celsius_l_3, icon_3, dt_txt_3);
*/
//Serial.printf("%s.%s: %s/%s ico:%s pop:%03u \x0a\x0c", day_3, month_3, celsius_h_3, celsius_l_3, icon_3, pop_3);


  httpData = "";

}

void Draw_Weather_Icon(String iicon, uint16_t ix, uint16_t iy)
{

/*
Day icon  Description
01d.png clear sky         Clear
02d.png few clouds        Clouds
03d.png scattered clouds  Clouds
04d.png broken clouds     Clouds
09d.png shower rain       Rain
10d.png rain              Rain
11d.png thunderstorm      Thunderstorm
13d.png snow              Snow
50d.png mist              Atmosphere

*/


     if ((iicon == "partlycloudy")||(iicon == "mostlysunny"))
  myGLCD.drawBitmap (ix, iy, 50, 50, partlycloudy, 1);
else if (iicon == "chanceflurries")
  myGLCD.drawBitmap (ix, iy, 50, 50, chanceflurries, 1);
else if ((iicon == "chancerain")||(iicon == "chancesleet"))
  myGLCD.drawBitmap (ix, iy, 50, 50, chancerain, 1);
else if (iicon == "chancesnow")
  myGLCD.drawBitmap (ix, iy, 50, 50, chancesnow, 1);
else if (iicon == "chancetstorms")
  myGLCD.drawBitmap (ix, iy, 50, 50, chancestorms, 1);
else if ((iicon == "01d")||(iicon == "01n"))
  myGLCD.drawBitmap (ix, iy, 50, 50, cler, 1);
else if ((iicon == "02d")||(iicon == "03d")||(iicon == "04d")||(iicon == "02n")||(iicon == "03n")||(iicon == "04n"))
  myGLCD.drawBitmap (ix, iy, 50, 50, cloudy, 1);
else if (iicon == "flurries")
  myGLCD.drawBitmap (ix, iy, 50, 50, flurries, 1);
else if ((iicon == "50d")||(iicon == "50n"))
  myGLCD.drawBitmap (ix, iy, 50, 50, fog, 1);
else if ((iicon == "mostlycloudy")||(iicon == "partlysunny"))
  myGLCD.drawBitmap (ix, iy, 50, 50, mostlycloudy, 1);
else if ((iicon == "10d")||(iicon == "09d")||(iicon == "09n")||(iicon == "10n"))
  myGLCD.drawBitmap (ix, iy, 50, 50, rain, 1);
else if (iicon == "13d")
  myGLCD.drawBitmap (ix, iy, 50, 50, snow, 1);
else if (iicon == "11d")
  myGLCD.drawBitmap (ix, iy, 50, 50, tstorms, 1);
else 
  myGLCD.drawBitmap (ix, iy, 50, 50, nodata, 1);


 
  
}

///////////////////////////////////////////////////////////////////////////////
void Draw_Time()
{
  uint8_t t_Month, t_Day, t_Hour, t_Minute, t_Second, t_Wday;
  uint16_t t_Year;

  uint16_t scaled_fon = 0;
  char rad_units[5];
  
  t_Month = month();
  t_Day = day();
  t_Year = year();
  t_Hour = hour();
  t_Minute = minute();
  t_Second = second();
  t_Wday = weekday();

//Serial.print("Ntm:");
//Serial.println(ntp_time);



if (t_Day != t_Date_displayed)
{
//time
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 3, 4, 136 , 46 );  
myGLCD.setColor(6,230,153);
myGLCD.drawRoundRect ( 3, 4, 136 , 46 );  

//dates
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 140, 13, 237 , 46 );  
myGLCD.setColor(6,230,153);
myGLCD.drawRoundRect ( 140, 13, 237 , 46 );  


t_Date_displayed = t_Day;
}

if (flag_redraw_weather_timeout_bar)
{
flag_redraw_weather_timeout_bar = false;
//progress weather
myGLCD.setColor(0,0,0);
myGLCD.fillRoundRect ( 1, 148, 240 , 154 );  
myGLCD.setColor(6,230,153);
myGLCD.drawLine ( 1, 154, 240 , 154 );  

myGLCD.drawLine ( 1, 148, 1 , 154 );  
myGLCD.drawLine ( 240, 148, 240 , 154 );  



  for(uint8_t dx=0; dx<238; dx+=15)
  {
    myGLCD.drawLine ( dx, 149, dx , 153 );
  }

}

if (flag_redraw_clock_timeout)
{
  flag_redraw_clock_timeout = false;
  //progress clock
myGLCD.setColor(0,0,0);
myGLCD.fillRect ( 140, 4, 230 , 11 );  
myGLCD.setColor(6,230,153);

//myGLCD.setColor(102,255,102);
myGLCD.drawLine ( 141, 4, 227 , 4 );  

myGLCD.drawLine ( 141, 4, 141 , 10 );  
myGLCD.drawLine ( 227, 4, 227 , 10 );  



  for(uint8_t dx=0; dx<85; dx+=15)
  {
    myGLCD.drawLine ( 141+dx, 4, 141+dx , 9 );
  }

}

if (sensor_update_counter > 70) myGLCD.setColor(255,102,102);
else if (sensor_update_counter > 55) myGLCD.setColor(255,255,102);
else myGLCD.setColor(102,255,102);

  myGLCD.drawLine (7, 162, 7+sensor_update_counter, 162);
  myGLCD.setColor(0,0,0);
  myGLCD.drawLine (7+sensor_update_counter, 162, 86, 162);


int x2 = 225-(81*clock_update_counter/clock_update_rate);

if (clock_update_status != last_clock_update_status) { flag_redraw_clock_timeout = true; last_clock_update_status = clock_update_status;}
switch (clock_update_status)
  {
    case 0: // no ntp
    myGLCD.setColor(255,10,10);
    myGLCD.fillRect ( 143, 6, 225 , 8 );  
    break;
    case 1: // ntp OK
    myGLCD.setColor(102,255,102);
    myGLCD.fillRect ( x2, 6, 225 , 7 );
    break;
    case 2: // ntp in progress
    myGLCD.setColor(10,255,255);
    myGLCD.fillRect ( 143, 6, 225 , 8 );  
    break;
  }

// WEATHER_INTERVAL // 146++
x2 = 237-(235*forecast_reload/WEATHER_INTERVAL);
//forecast_reload

    myGLCD.setColor(102,255,102);
    myGLCD.fillRect ( x2, 150, 237 , 151 );

  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(0,0,0);
  myGLCD.setFont(SixteenSegment24x36);

sprintf(txt, "%02u:%02u", t_Hour, t_Minute);
//if (t_Second % 2) sprintf(txt, "%02u %02u", t_Hour, t_Minute); else sprintf(txt, "%02u:%02u", t_Hour, t_Minute);
printRus(myGLCD, txt, 8, 8 ,0);

  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(0,0,0);
  myGLCD.setFont(RusFixedSysFont);
sprintf(txt, "%02u.%02u.%04u", t_Day, t_Month, t_Year);
myGLCD.print(txt, 150, 16 ,0);

String signal_ico;
signed char rssi = WiFi.RSSI();
rssi = rssi+50; // будет -50/0

if ((rssi > 0)||(rssi < -50)) rssi = -50;

if (rssi > -10) signal_ico = "\xB5";
else if (rssi > -25) signal_ico = "\xB6";
else if (rssi > -40) signal_ico = "\xB7";
else signal_ico = "\xB8";

myGLCD.print(signal_ico, 232, 0 ,0);

//  Serial.print("Signal: ");
//  Serial.println(WiFi.RSSI());


switch (t_Wday)
  {
    case 1:
    strcpy(txt, "Воскресенье");
    break;
    case 2:
    strcpy(txt, "Понедельник");
    break;
    case 3:
    strcpy(txt, "Вторник");
    break;
    case 4:
    strcpy(txt, "Среда");
    break;
    case 5:
    strcpy(txt, "Четверг");
    break;
    case 6:
    strcpy(txt, "Пятница");
    break;
    case 7:
    strcpy(txt, "Суббота");
    break;
    default:
    strcpy(txt, "n/a");
    break;
  }
  printRus(myGLCD, txt, 146, 31 ,0);

// INTERNAL SENSORS
//Home

  myGLCD.setColor(102,255,102);
  myGLCD.setBackColor(0,0,0);
  myGLCD.setFont(DotMatrix_Num);
  
  if (((int)local_t > -99)&&((int)local_t < 99))  d_local_t = local_t; // либа ппц глючная
  
  sprintf(txt, "%3i", (int)d_local_t);
  printRus(myGLCD, txt, 150, 189 ,0);

  if (((int)local_h > 0)&&((int)local_h < 100))  d_local_h = local_h; // либа ппц глючная
  sprintf(txt, "%2i", (int)d_local_h);
  printRus(myGLCD, txt, 150, 223 ,0);




if (local_fon > 999999) { scaled_fon = local_fon/1000000; strcpy(rad_units, "R/H "); }
else if (local_fon > 999) { scaled_fon = local_fon/1000; strcpy(rad_units, "mR/H"); }
else{ scaled_fon = local_fon; strcpy(rad_units, "uR/H"); }

  sprintf(txt, "%3i", scaled_fon);
  printRus(myGLCD, txt, 152, 259 ,0);
  myGLCD.setFont(RusFixedSysFont);
  printRus(myGLCD, rad_units, 202, 269 ,0);


  myGLCD.setFont(RusFixedSysFont);
      if (local_fon > 120){ sprintf(txt, "   ОПАСНЫЙ"); myGLCD.drawBitmap (214, 287, 23, 30, rad_crit, 1); }
      else if (local_fon > 50) { sprintf(txt, "повышенный"); myGLCD.drawBitmap (214, 287, 23, 30, rad_warn, 1); }
      else  { sprintf(txt, "нормальный"); myGLCD.drawBitmap (214, 287, 23, 30, rad_ok, 1); }
 printRus(myGLCD, txt, 129, 303 ,0);


}

/**
 * Соединение с WiFi
 */
bool ConnectWiFi(const char *ssid, const char *pass) {
  // Три попытки соединения по WiFi

    sprintf(txt, ">Connect to %s", ssid);
    myGLCD.print(txt, 2, 88 ,0);

  for ( int i = 0; i < 3; i++) {
    myGLCD.print(String("\xC5"), 2+(9*i), 102 ,0);

    Serial.print("\nConnecting to: ");
    Serial.print(ssid);
    Serial.print(" pass: ");
    Serial.println(pass);
    WiFi.begin(ssid, pass);
    delay(1000);
    // Максиммум 12 раз проверка соединения
    for ( int j = 0; j < 12; j++ ) {
      if (WiFi.status() == WL_CONNECTED) {
        Serial.print("\nWiFi connect true: ");
        Serial.print(WiFi.localIP());
        Serial.print("/");
        Serial.print(WiFi.subnetMask());
        Serial.print("/");
        Serial.println(WiFi.gatewayIP());
    
        sprintf(txt, "Linked to %s!", ssid);
        myGLCD.print(txt, 2, 116 ,0);  
        
        
        tmip = "IP: " + ipToString(WiFi.localIP());
        myGLCD.print(tmip, 2, 130 ,0);
        
        return true;
      }
      delay(1000);
      Serial.print(WiFi.status());
      if (WiFi.status() == WL_DISCONNECTED) WiFi.begin(ssid, pass); // иначе будет тупить при реконнекте
    }
  }
  

    sprintf(txt, "Connect to %s FAIL!", ssid);
    myGLCD.print(txt, 2, 116 ,0);

    myGLCD.print(String("Resetting now!"), 2, 130 ,0);


  Serial.println("\nConnect WiFi failed ...");
  return false;
}

/*-------- NTP code ----------*/

const int NTP_PACKET_SIZE = 48; // NTP time is in the first 48 bytes of message
byte packetBuffer[NTP_PACKET_SIZE]; //buffer to hold incoming & outgoing packets

time_t getNtpTime()
{
  IPAddress ntpServerIP; // NTP server's ip address

  while (Udp.parsePacket() > 0) ; // discard any previously received packets
  Serial.println("Transmitting NTP Request...");
  // get a random server from the pool
  

  WiFi.hostByName(ntpServerNameS[ntp_rotation], ntpServerIP);
  Serial.print(ntpServerNameS[ntp_rotation]);
  Serial.print(": ");
  Serial.println(ntpServerIP);
clock_update_status = 3;
if (screen == 0) 
        {
        tmip = ">NTP URL: " + (String)ntpServerNameS[ntp_rotation];
        myGLCD.print(tmip, 2, 158 ,0);
        tmip = ">NTP IP: " + ipToString(ntpServerIP);
        myGLCD.print(tmip, 2, 172 ,0);
        }

if (ntp_rotation++ > 4) ntp_rotation = 0;
  
  sendNTPpacket(ntpServerIP);
  uint32_t beginWait = millis();
  while (millis() - beginWait < NTP_TIMEOUT) {
    int size = Udp.parsePacket();
    if (size >= NTP_PACKET_SIZE) {
      Serial.println("Received NTP Response");
if (screen == 0) myGLCD.print(String("NTP answer OK!               "), 2, 186 ,0);
      err_count = 0;
      clock_update_status = 1;
      Udp.read(packetBuffer, NTP_PACKET_SIZE);  // read packet into the buffer
      unsigned long secsSince1900;
      // convert four bytes starting at location 40 to a long integer
      secsSince1900 =  (unsigned long)packetBuffer[40] << 24;
      secsSince1900 |= (unsigned long)packetBuffer[41] << 16;
      secsSince1900 |= (unsigned long)packetBuffer[42] << 8;
      secsSince1900 |= (unsigned long)packetBuffer[43];
      setSyncInterval(NTP_INTERVAL);
      clock_update_rate = NTP_INTERVAL;
      return secsSince1900 - 2208988800UL + timeZone * SECS_PER_HOUR;
    }
  }
  setSyncInterval(10); // небыло ответа, снова пробовать через 10 сек
  clock_update_rate = 10;
  Serial.println("No NTP Response");
  err_count ++;
  clock_update_status = 0;
if (screen == 0) myGLCD.print(String("NTP Timeout! Retry in 10 s."), 2, 186 ,0);
  return 0; // return 0 if unable to get the time
}

// send an NTP request to the time server at the given address
void sendNTPpacket(IPAddress &address)
{
  // set all bytes in the buffer to 0
  memset(packetBuffer, 0, NTP_PACKET_SIZE);
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12] = 49;
  packetBuffer[13] = 0x4E;
  packetBuffer[14] = 49;
  packetBuffer[15] = 52;
  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp:
  Udp.beginPacket(address, 123); //NTP requests are to port 123
  Udp.write(packetBuffer, NTP_PACKET_SIZE);
  Udp.endPacket();
}


void printRus(UTFT rus, char *st, int x, int y, int deg){
//void printRus(UTFT rus, const char *st, int x, int y, int deg){
 int stl, i;

 stl = strlen(st);
 if (rus.orient==PORTRAIT){
    if (x==RIGHT) x=(rus.disp_x_size+1)-(stl*rus.cfont.x_size);
    if (x==CENTER) x=((rus.disp_x_size+1)-(stl*rus.cfont.x_size))/2;
 } else {
  if (x==RIGHT) x=(rus.disp_y_size+1)-(stl*rus.cfont.x_size);
  if (x==CENTER) x=((rus.disp_y_size+1)-(stl*rus.cfont.x_size))/2;
 }
 uint8_t utf_high_byte = 0;
 uint8_t ch, ch_pos = 0;
 for (i = 0; i < stl; i++) {
  ch = st[i];
   if ( ch >= 128) {
     if ( utf_high_byte == 0 && (ch ==0xD0 || ch == 0xD1)) {
         utf_high_byte = ch;
      continue;
     } else {
     if ( utf_high_byte == 0xD0) {
    if (ch == 0x81) { //Ё
      ch = 6;
    } else {
    if(ch <= 0x95) {
       ch -= 0x90;
    } else if( ch < 0xB6){
    ch -= (0x90 - 1);
    } else {
    ch -= (0x90 - 2);
    }}
    ch = pgm_read_byte(utf8_rus_charmap + ch);
    } else if (utf_high_byte == 0xD1) {
           if (ch == 0x91) {//ё
           ch = 39;
       } else {
        ch -= 0x80;
        ch += 50;
       }
           ch = pgm_read_byte(utf8_rus_charmap + ch);
    }
    utf_high_byte = 0;
   }
   } else {
     utf_high_byte = 0;
     }
     if (deg==0) {rus.printChar(ch, x + (ch_pos * (rus.cfont.x_size)), y);} else {
          rus.rotateChar(ch, x, y, ch_pos, deg);
        }
      ++ch_pos;
 }
};

String macToStr(const uint8_t* mac)
{
  String result;
  for (int i = 0; i < 6; ++i) {
    result += String(mac[i], 16);
    if (i < 5)
      result += ':';
  }
  return result;
}

String ipToString(IPAddress ip){
  String s="";
  for (int i=0; i<4; i++)
    s += i  ? "." + String(ip[i]) : String(ip[i]);
  return s;
}

void launchWeb() {
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.print("Local IP: ");
  Serial.println(WiFi.localIP());
  Serial.print("SoftAP IP: ");
  Serial.println(WiFi.softAPIP());
  createWebServer();
  // Start the server
  server.begin();
  Serial.println("Server started");
}



void createWebServer()
{
      IPAddress ip = WiFi.softAPIP();
      String ipStr = String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]);
      content = "<!DOCTYPE HTML>\r\n<html><body bgcolor='black' text='green'>Welcome, Overseer. <hr>WiFi setup:";
      content += ipStr;
      content += "<hr>";
      content += st;
      content += "<hr><form method='get' action='setting'><label>SSID: </label><input name='ssid' length=32 value='";
      if (String(AP_SSID).length()<32) content += String(AP_SSID);
      content += "'><br><label>PASS: </label><input name='pass' length=64 value='";
      if (String(AP_PASS).length()<64) content += String(AP_PASS);
      content += "'><br><label>TimeZone: </label><input name='timezone' length=3 value='";
      if (String(timeZone).length()<4) content += timeZone;
      content += "'><hr>openweathermap.org setup:<br><label>WU Key: </label><input name='wu_key' length=32 value='";
      if (String(wu_key).length()<35) content += wu_key;
      content += "'><br><label>My Location: </label><input name='wu_location' length=26 value='";
      if (String(wu_location).length()<26) content += wu_location;
      content += "'><br><hr><br><input type='submit'></form></body></html>\r\n";

//Serial.println("Content:");
//Serial.println(content);

    server.on("/", []() {

      server.send(200, "text/html", content);
    });
    server.on("/setting", []() {
      String qsid = server.arg("ssid");
      String qpass = server.arg("pass");
      String qtimezone = server.arg("timezone");
      String q_wu_key = server.arg("wu_key");
      String q_wu_location = server.arg("wu_location");
      if (qsid.length() > 0 && qtimezone.length() > 0) {
        Serial.println("clearing eeprom");
        EEPROM.begin(158);
        for (int i = 0; i < 157; ++i) {
          EEPROM.write(i, 0);
        }
        EEPROM.end();
        
        EEPROM.begin(158);
        Serial.print("writing eeprom ssid:");
        Serial.println(qsid);
        for (int i = 0; i < qsid.length(); ++i)
        {
          EEPROM.write(i, qsid[i]);
//          Serial.print("Wrote: ");
//          Serial.println(qsid[i]);
        }
        Serial.print("writing eeprom pass:");
        Serial.println(qpass);
if (qpass.length() < 8)
       {
        for (int i = 0; i < 96; ++i)
        {
          EEPROM.write(32 + i, 0);
//          Serial.print("Wrote: ");
//          Serial.println(qpass[i]);
        }
       }
       else
       {
        for (int i = 0; i < qpass.length(); ++i)
        {
          EEPROM.write(32 + i, qpass[i]);
//          Serial.print("Wrote: ");
//          Serial.println(qpass[i]);
        }
       }
        for (int i = 0; i < qtimezone.length(); ++i)
        {
          EEPROM.write(96 + i, qtimezone[i]);
//          Serial.print("Wrote: ");
//          Serial.println(qtimezone[i]);
        }

        Serial.print("writing eeprom WU key:");
        Serial.println(q_wu_key);
        for (int i = 0; i < q_wu_key.length(); ++i)
        {
          EEPROM.write(99 + i, q_wu_key[i]);
//          Serial.print("Wrote: ");
//          Serial.println(q_wu_key[i]);
        }

        Serial.print("writing eeprom WU Location:");
        Serial.println(q_wu_location);
        for (int i = 0; i < q_wu_location.length(); ++i)
        {
          EEPROM.write(131 + i, q_wu_location[i]);
//          Serial.print("Wrote: ");
//          Serial.println(q_wu_location[i]);
        }

        EEPROM.commit();
        EEPROM.end();
        content = "<!DOCTYPE HTML>\r\n<html><body bgcolor='black' text='green'><br><hr>\"Success\": saved to EEPROM... reset to boot new settings!<hr><br></body></html>";
        statusCode = 200;
      } else {
        content = "<!DOCTYPE HTML>\r\n<html><body bgcolor='black' text='green'><br><hr>\"Error\": 404 not found</body></html>";
        //content = "{\"Error\":\"404 not found\"}";
        statusCode = 404;
        Serial.println("Sending 404");
      }
       server.send(200, "text/html", content);
      //server.send(statusCode, "application/json", content);

    });
//////////////////////////////////
////////////////////////////////////
}

